import System;
import System.Xml;

// Load the XML document
var xDoc:XmlDocument = new XmlDocument();
xDoc.Load("11-1.xml");

// Get the root element
var xRootNode:XmlNode = xDoc.DocumentElement;

if ( xRootNode.HasChildNodes ) {
    // Make sure we have child nodes
    var i:int = 0;
    
    Console.WriteLine("-------- Child Nodes using ChildNodes Collection");
    for(i = 0; i < xRootNode.ChildNodes.Count; i++) {
        Console.WriteLine("Name       : " + xRootNode.ChildNodes[i].Name);
        Console.WriteLine("LocalName  : " + xRootNode.ChildNodes[i].LocalName);
        Console.WriteLine("Value      : " + xRootNode.ChildNodes[i].Value);
        Console.WriteLine("Children?  : " + xRootNode.ChildNodes[i].HasChildNodes);
        Console.WriteLine();
    }
    
    // Lets print the First and Last as well
    Console.WriteLine("-------- Child Nodes using FirstChild and LastChild Properties");
    Console.WriteLine("Name       : " + xRootNode.FirstChild.Name);
    Console.WriteLine("LocalName  : " + xRootNode.FirstChild.LocalName);
    Console.WriteLine("Value      : " + xRootNode.FirstChild.Value);
    Console.WriteLine("Children?  : " + xRootNode.FirstChild.HasChildNodes);
    Console.WriteLine();
    Console.WriteLine("Name       : " + xRootNode.LastChild.Name);
    Console.WriteLine("LocalName  : " + xRootNode.LastChild.LocalName);
    Console.WriteLine("Value      : " + xRootNode.LastChild.Value);
    Console.WriteLine("Children?  : " + xRootNode.LastChild.HasChildNodes);
    Console.WriteLine();
    
    // Lets get one by name
    Console.WriteLine("-------- Child Node access by name");
    Console.WriteLine("Name       : " + xRootNode["LINE"].Name);
    Console.WriteLine("LocalName  : " + xRootNode["LINE"].LocalName);
    Console.WriteLine("Value      : " + xRootNode["LINE"].Value);
    Console.WriteLine("Children?  : " + xRootNode["LINE"].HasChildNodes);
    Console.WriteLine();
}
