import System;
import System.IO;
import System.Xml;

var xDoc:XmlDocument = new XmlDocument();
var xRootElement:XmlNode;
var i:int;
var xLastInternal:XmlNode;

// Load the document from the previous Code Listing
xDoc.Load("11-6.xml");

// Now lets modify some existing values
xRootElement = xDoc.DocumentElement;
for(i = 0; i < xRootElement.ChildNodes.Count; i++) {
    if ( xRootElement.ChildNodes[i].LocalName == "INTERNAL" ) {
        xRootElement.ChildNodes[i].Attributes["Type"].Value = "Attribute - " + i;
        xRootElement.ChildNodes[i].FirstChild.Value = "Old Element - " + i;
        
        xLastInternal = xRootElement.ChildNodes[i];
    }
}

// At the same time we need to add a new INTERNAL node
var xInternalNode:XmlNode = xDoc.CreateNode(XmlNodeType.Element, "INTERNAL", null);
var xTextNode:XmlNode = xDoc.CreateNode(XmlNodeType.Text,  null, null);
var xTypeAttr:XmlAttribute = xDoc.CreateAttribute("Type");

xTextNode.Value = "New Element";
xInternalNode.AppendChild(xTextNode);

xTypeAttr.Value = "New Attribute";
xInternalNode.Attributes.Append(xTypeAttr);

xRootElement.InsertAfter(xInternalNode, xLastInternal);

var w:XmlTextWriter = new XmlTextWriter("11-7.xml", null);
w.Formatting = Formatting.Indented;
w.Indentation = 1;
w.IndentChar = '\t';
xDoc.WriteTo(w);
w.Close();