import System;

var OriginalValue:int = 222; // A relatively mixed up set of bits
var NewValue:int = 0;
var XorSalt:int = 11; // We only want 4 bits of Salt, so use values <15
var MaskHigh:int = 240;
var MaskLow:int = 15;

var LowValue:int = 0;
var HighValue:int = 0;

// The algorithm is simple
//   1.  Work on the top and bottom halves separately
//   2.  Use an XOR NOT mask on the top half
//   3.  Use a NOT XOR mask on the bottom half

Console.WriteLine("\nShowing values after we mask them out");
LowValue = OriginalValue & MaskLow;   // Get bottom 4 bits
Console.WriteLine(Convert.ToString(LowValue, 2));

HighValue = OriginalValue & MaskHigh; // Get top 4 bits
HighValue >>= 4; // Lets move the top 4 bits down to the bottom 4
Console.WriteLine(Convert.ToString(HighValue, 2));

Console.WriteLine("\nShowing values after perform the *encryption*");
LowValue ^= XorSalt;
LowValue = ~LowValue; // After we NOT we have to mask off our low 4 bits
LowValue &= MaskLow;
Console.WriteLine(Convert.ToString(LowValue, 2));

HighValue = ~HighValue;
HighValue &= MaskLow; // After we NOT we have to mask off our low 4 bits
HighValue ^= XorSalt;
Console.WriteLine(Convert.ToString(HighValue, 2));

Console.WriteLine("\nShowing original value and the new value");
NewValue = LowValue + (HighValue << 4); // Put the value back together
Console.WriteLine(Convert.ToString(OriginalValue, 2));
Console.WriteLine(Convert.ToString(NewValue, 2));
