import System;
import System.Collections;

class OrderedHash {
    private var _sortList = new ArrayList();
    private var _arrayList = new ArrayList();
    private var _hashTable = new Hashtable();
    
    public function Clear() : void {
        _arrayList.Clear();
        _hashTable.Clear();
    }
    
    public function Add(emp:Employee ) : int {
        if ( _hashTable.ContainsKey(emp.Name) ) {
            return -1;
        }
        
        _hashTable[emp.Name] = emp;
        return _arrayList.Add(emp);
    }
    
    public function Sort(dir:Boolean) : ArrayList {
        _sortList = _arrayList.Clone();
        
        if ( dir )
            _sortList.Sort(new EmployeeSortAsc());
        else
            _sortList.Sort(new EmployeeSortDesc());
            
        return _sortList;
    }
    
    public function Lookup(key:String) : Employee {
        return _hashTable[key];
    }
    
    public function get OrderedList() : ArrayList {
        return _arrayList;
    }
}

class EmployeeSortAsc implements IComparer {
    function Compare(x:Object, y:Object) : int {
        var emp1name:String = Employee(x).Name;
        var emp2name:String = Employee(y).Name;
        
        return emp1name.CompareTo(emp2name); // Compare using String comparer
    }
}

class EmployeeSortDesc implements IComparer {
    function Compare(x:Object, y:Object) : int {
        var emp1name:String = Employee(x).Name;
        var emp2name:String = Employee(y).Name;
        
        return emp2name.CompareTo(emp1name); // Reverse Comparison
    }
}

class Employee {
    private var name:String;
    
    function Employee(name:String) {
        this.name = name;
    }
    
    public function get Name() : String {
        return this.name;
    }
}

var rand:Random = new Random();
var o:OrderedHash = new OrderedHash();
var j:int = 0;
var empNumber:int = 0;
for(j = 0; j < 10; j++) {
    empNumber = rand.Next(1000,10000);
    
    o.Add(new Employee("Employee" + empNumber));
}

Console.WriteLine();
Console.WriteLine("Unsorted");
for(j = 0; j < 10; j++) {
    Console.WriteLine(o.OrderedList[j].Name);
}


Console.WriteLine();
Console.WriteLine("Sorted ASC");
for(j = 0; j < 10; j++) {
    Console.WriteLine(o.Sort(true)[j].Name);
}

Console.WriteLine();
Console.WriteLine("Sorted DESC");
for(j = 0; j < 10; j++) {
    Console.WriteLine(o.Sort(false)[j].Name);
}

Console.WriteLine();
Console.WriteLine("Lookups");
Console.WriteLine(o.Lookup("Employee" + empNumber).Name);