import System;

public System.AttributeUsageAttribute(
    AttributeTargets.All,
    Inherited=false,
    AllowMultiple=false)
class DocumentationAttribute extends System.Attribute {
    private var shortName:String;
    private var lastModified:String;
    private var author:String;
    private var description:String;
    
    // One require property
    function DocumentationAttribute(shortName:String) {
        this.shortName = shortName;
    }
    
    // Since it is required we only need a get;
    public function get ShortName() : String {
        return shortName;
    }

    // These are optional and name so we need a get; set;
    public function get LastModified() : String {
        return lastModified;
    }
    public function set LastModified(value:String) {
        lastModified = value;
    }

    public function get Author() : String {
        return author;
    }
    public function set Author(value:String) {
        author = value;
    }

    public function get Description() : String {
        return description;
    }
    public function set Description(value:String) {
        description = value;
    }
}

public DocumentationAttribute("MyClass", LastModified="8/31/2001", Author="Justin Rogers", Description="Whoo Hoo")
class MyClass {
}
